/*
 * main.c
 *
 *      Author: liuwei
 *
 *       */
#include "HY16F188.h"
#include "DrvGPIO.h"
#include "DrvCLOCK.h"
#include "DrvTimer.h"
#include "seg7.h"
#include "DrvADC.h"
#include "DrvPMU.h"
#include "System.h"
#include "SpecialMacro.h"
#include "DrvREG32.h"
#include "DrvI2C.h"
#include "DrvHWI2C.h"
#include "HY2613.h"
#include "my define.h"

unsigned int check_origin(void);
unsigned int Displaybuf[18];
unsigned long ADCbuffer[16]={0};
unsigned long ADCbufferone[1024]={0};
unsigned int indec=0,adcnum=0,summation=0,check_00,check_2k;
unsigned int adzero,no1,decorticate,total,adcnuma,adcnumb; 
int i=0,interrupt_flag,aa=0, throwtwo,bb,cc,z=0,lcd_flag=0,nums,buf[4],internal;
unsigned int price,gradients,gradientbuf;

unsigned char buffer;


/*void display(void);
void ram2lcd(char data_reg[16]);//*/

/*void I2C_Start(void);
void I2C_Stop(void);
void I2C_NOP(void);
void I2C_Write(unsigned int I2C_Data);
void I2C_NACK(void);
void I2C_ACK(void);
void I2C_INI(void);

void INI_DISPLAY(void);
void On_Display(void);//*/

unsigned int databuffer;
int par,loop,addr, disctl,blkctl,apctl,modeset,adset,error,lcd_1,lcd_2;
int pt3_5;
int kg_check;

void InitalADC(void);

void Delay (unsigned int num);
void Ram_Write_Clear(void);
void LCD_DATA_DISPLAY(unsigned int databuffer,int num);
unsigned int gradient(unsigned int check_00,unsigned int check_2k);
void bitaverage(void);
void press_key(void);
void read_key(void);

int main(void)
{

 Delay(0x40000);
 addr=0x7c,disctl=0xbc,blkctl=0xf0,apctl=0xfc,modeset=0xc8,adset=0;kg_check=0;

 //On_Display();
   
 DrvCLOCK_EnableHighOSC(E_INTERNAL,50);//enable internal high speed OSC
 DrvCLOCK_SelectIHOSC(1); 			    //choose internal frequency is 2mhz
 DrvCLOCK_SelectMCUClock(0,0);		  //CPU clock is hs_ck/1
 
 //PT2
 DrvGPIO_Open(E_PT2,0xff,E_IO_OUTPUT);
 DrvGPIO_Open(E_PT1,0xff,E_IO_INPUT);
 
 InitalI2C();
 InitalADC();
 SYS_EnableGIE(7,0x3f);
 Ini_Display(); //INI_DISPLAY();
 Ram_Write_Clear();

 i=0;summation=0;throwtwo=0;interrupt_flag=0;
  
 LCD_DATA_DISPLAY(0,0);
 LCD_DATA_DISPLAY(0,1);
 //LCD_DATA_DISPLAY(0,2);

 z=0;
 int y=0,n=0;
 Displaybuf[6]=0;Displaybuf[7]=0;
 Displaybuf[8]=0;Displaybuf[9]=0;
 Displaybuf[10]=0;Displaybuf[11]=0;
 
 lcd_1=0;lcd_2=0;
 int j;
 for(j=0;j<100;j++){bitaverage();}
 adzero=adcnum;
 internal=0;
 no1=0;price=0;total=0;decorticate=0;
 
 DrvGPIO_Open(E_PT3,0x20,E_IO_INPUT);    //set PT3 INPUT
 DrvGPIO_Open(E_PT3,0x20,E_IO_PullHigh); //enable PT3 pull high R
 DrvGPIO_Open(E_PT3,0x10,E_IO_OUTPUT);
 DrvGPIO_SetPortBits(E_PT3,0xef);

 while(1)
 {
   bitaverage();//Ūadc   
   if(adcnum<adzero){adzero=adcnum;}//P_0I
   else{if(adcnum-adzero<4){adcnum=adzero;}}
   if(adcnuma>adcnum){if((adcnuma-adcnum)>3){adcnuma=adcnum;}}
   else{if((adcnum-adcnuma)>3){adcnuma=adcnum;}}

   gradientbuf=adcnuma-adzero;
   
   pt3_5=DrvGPIO_GetBit(E_PT3,5);//read PT3.5 pin high or low
   if(pt3_5==1)
   {
     nums=(gradientbuf*2000)/(check_2k-check_00);//p`qAg
     kg_check=S_g;
   }
   else
   {
     nums=gradientbuf;//uADCƭ
     kg_check=0;
   }

   if(nums<decorticate){nums=0;}
   else{nums=nums-decorticate;}

   if(internal==0){LCD_DATA_DISPLAY(nums,0);}//`q
   else if(internal==1)	{LCD_DATA_DISPLAY(adcnum,0);}//`q 
   total=(price*nums)/1000;//`B
   LCD_DATA_DISPLAY((unsigned int)total,1);//`B
   //䳡
   
   no1+=1;
   if(no1==1000){lcd_1=0;lcd_2=0;buf[0]=0;buf[1]=0;buf[2]=0;buf[3]=0;no1=0;}
   read_key();

   if(n==cc){y+=1;}
   else{y=0;}

   n=cc;
   if(y==1)
   {
     switch(cc)
     {
       case 0xff:{break;}//[OK][NO Touch]
       case 0x7e://[K1]=[S0]
       {
         lcd_1+=1;
         LCD_DATA_DISPLAY(0,2);
         while(cc!=0xff){read_key();}
         break;
       }
       case 0xbe://[K2]=[S1]
       {
         lcd_1+=1;
         LCD_DATA_DISPLAY(1,2);
         while(cc!=0xff){read_key();}
         break;
       }
       case 0xde://[K3]=[S2]
       {
         lcd_1+=1;
         LCD_DATA_DISPLAY(2,2);
         while(cc!=0xff){read_key();}
         break;
       }
       case 0xee://[KA]=[S3]
       {
         lcd_1+=1;
         LCD_DATA_DISPLAY(3,2);
         while(cc!=0xff){read_key();}
         break;
       }
       case 0x7d://[K4]=[S4]
       {
         lcd_1+=1;
         LCD_DATA_DISPLAY(4,2);
         while(cc!=0xff){read_key();}
         break;
       }
       case 0xbd://[K5]=[S5]
       {
         lcd_1+=1;
         LCD_DATA_DISPLAY(5,2);
         while(cc!=0xff){read_key();}
         break;
       }
       case 0xdd://[K6]=[S6]
       {
       	 lcd_1+=1;
       	 LCD_DATA_DISPLAY(6,2);
       	 while(cc!=0xff){read_key();}
       	 break;
       }
       case 0xed://[KB]=[S7]
       {
         lcd_1+=1;
         LCD_DATA_DISPLAY(7,2);
         while(cc!=0xff){read_key();}
         break;
       }
       case 0x7b://[K7]=[S8]
       {
         lcd_1+=1;
         LCD_DATA_DISPLAY(8,2);
         while(cc!=0xff){read_key();}
         break;
       }
       case 0xbb://[K8]=[S9]
       {
         lcd_1+=1;
         LCD_DATA_DISPLAY(9,2);
         while(cc!=0xff){read_key();}
         break;
       }
       case 0xdb://[K9]=[SA][0KG]
       {
         LCD_DATA_DISPLAY(adcnum,3);
         Delay(0x60000);
         check_00= check_origin();
         adzero=check_00;
         while(cc!=0xff){read_key();}
         LCD_DATA_DISPLAY(adcnum,4);
         Delay(0x40000);
         break;
       }
       case 0xeb://[KC]=[SB][ե2KGI]
       {
         LCD_DATA_DISPLAY(0,5);
         check_2k= check_origin();
         Delay(0x60000);
         while(cc!=0xff){read_key();}
         LCD_DATA_DISPLAY(adcnum,4);
         Delay(0x40000);
         break;
       }
       case 0x77://[S*]=[SC]
       {
         lcd_1=0;lcd_2=0;
         buf[0]=0;buf[1]=0;buf[2]=0;buf[3]=0;
         internal=0;
         LCD_DATA_DISPLAY(0,2);
         decorticate=0;
         while(cc!=0xff){read_key();}    
         break;
       }
       case 0xb7://[S0]=[SD]
       {
         internal=1;
         while(cc!=0xff){read_key();}
         break;
       }
       case 0xd7://[S#]=[SE]
       {
         if(lcd_2==0){lcd_1=0;lcd_2+=1;}
         while(cc!=0xff){read_key();}
         break;
       }
       case 0xe7://[SF]=[SF]
       {
         decorticate=nums;
         while(cc!=0xff){read_key();}
         break;
       }
     }   
   }
 }
 return 0;
}

void read_key(void)
{
  DrvGPIO_Open(E_PT2,0xff,E_IO_OUTPUT);
  DrvGPIO_SetPortBits(E_PT2,0xf0);
  DrvGPIO_Open(E_PT2,0xf0,E_IO_INPUT);
  aa=DrvGPIO_GetPortBits(E_PT2);
  aa&=0xf0;
  DrvGPIO_Open(E_PT2,0xff,E_IO_OUTPUT);
  DrvGPIO_SetPortBits(E_PT2,0x0f);
  DrvGPIO_Open(E_PT2,0x0f,E_IO_INPUT);
  bb=DrvGPIO_GetPortBits(E_PT2);
  bb&=0x0f;
  cc=aa^bb;
}

unsigned int check_origin(void)
{
  unsigned int checknum=0,checkbuf=0;
  while(checknum<100)
  {
    bitaverage();
    //checkbuf=adcnum;
    if(-5<(int)checkbuf-(int)adcnum||(int)checkbuf-(int)adcnum<5)
    {checknum+=1;}
    else
    checknum=0;
    checkbuf=adcnum;
  }
  return checkbuf;
} 
unsigned int gradient(unsigned int check_00,unsigned int check_2k)
{
  unsigned int checkzero,checkone;
  checkzero=check_00;
  checkone=check_2k;
  gradientbuf=(2000/(check_2k-check_00));
  return gradientbuf;
}
void bitaverage(void)
{
  if(interrupt_flag==1)
  {
    interrupt_flag=0;
    if(throwtwo<5){throwtwo+=1;}
    if(throwtwo>2)
    {
      if(throwtwo==3)
      {
        int a;
        for(a=0;a<16;a++)
        {
          ADCbuffer[a]=indec;
          summation+=ADCbuffer[a];
        }
        asm("NOP");
      }
      else
      {
        summation-=ADCbuffer[i];
        ADCbuffer[i]=indec;
        summation+=ADCbuffer[i];
        i=i+1;
        if(i>15){i=0;}
        adcnum=summation/16;
        asm("NOP");
      }
    }
  }
}

void InitalADC(void)
{
  //set ADC input pin
  DrvADC_PInputChannel(ADC_Input_AIO0);//setting positive input is AIO0
  DrvADC_NInputChannel(ADC_Input_AIO1);//setting negative input is AIO1
  
  DrvADC_InputSwitch(0);     //setting input switch is open
  DrvADC_RefInputShort(OPEN);//setting reference input switch is open
  
  DrvADC_Gain(7,3);//set AD  GAIN is PGA * GAIN = 128
  //set ADC offset
  DrvADC_DCoffset(0);//setting ADC DC input offset is 0 VREF
  //set ADC input reference voltage
  DrvADC_RefVoltage (0,0);//setting input VREF:PV=adda , NV=AIO3
  DrvADC_FullRefRange(1);//setting VREF rang input select
  //set ADC comb filter
  DrvADC_OSR(2);//ADC_CK/128 OSR=2560
  DrvADC_CombFilter(1);//enable OSR
  //set ADC clock
  DrvADC_ClkEnable(0,1);//setting ADC CLOCK ADCK=HS_CK/6 &rising edge is high
   //set VDDA voltage
  DrvPMU_VDDA_LDO_Ctrl(E_LDO);//enable LDO
  DrvPMU_VDDA_Voltage(E_VDDA2_4);//setting VDDA=2.4V
  
  DrvPMU_BandgapEnable();//band gap voltage
  DrvPMU_REFO_Enable();//enable REFO
  DrvPMU_AnalogGround(1);//set analog enable buffer and use internal source
  DrvPMU_LDO_LowPower(1);//low power & sleep mode
  Delay(0x1000);
  //set ADC interrupt
  DrvADC_EnableInt();//enable ADC interrupt
  DrvADC_ClearIntFlag();//clear ADC interrupt flag
  DrvADC_Enable();  // enable ADC and start ADC
}

void Ram_Write_Clear(void)//ram write the LCD
{
  int i=0; 

  for(i=0;i<0x14;i++)
  {
    Displaybuffer[i]=0x00;
  }
  RAM2LCD(Displaybuffer,0x14);

}

//ram write the LCD
void LCD_DATA_DISPLAY(unsigned int databuffer,int num)
{
  unsigned int buffer1,buffer2,buffernum,bufferi,a,b,c,d;
  //unsigned int Displaybuffer[32];
  switch(num)
  {
    case 0:
    {
      buffer1=databuffer;
      adset=0;buffernum=11;bufferi=6;
      Displaybuffer[6]=seg[buffer1/10000];
      buffer1=buffer1%10000;
      Displaybuffer[7]=seg[buffer1/1000]|seg_h;
      buffer1=buffer1%1000;
      Displaybuffer[8]=seg[buffer1/100];
      buffer1=buffer1%100;
      Displaybuffer[9]=seg[buffer1/10];
      buffer1=buffer1%10;
      Displaybuffer[10]=seg[buffer1]|kg_check;

      break;
    }
    case 3:
    {
      buffer1=databuffer;
      adset=0;buffernum=11;bufferi=6;
      Displaybuffer[6]=seg[12];
      Displaybuffer[7]=seg[10];
      Displaybuffer[8]=seg[16];
      Displaybuffer[9]=seg[0];
      Displaybuffer[10]=seg[0];
      break;
    }
    case 4:
    {
      buffer1=databuffer;
      adset=0;buffernum=11;bufferi=6;
      Displaybuffer[6]=seg[17];
      Displaybuffer[7]=seg[10];
      Displaybuffer[8]=seg[5];
      Displaybuffer[9]=seg[5];
      Displaybuffer[10]=seg[18];
      break;
    }
    case 5:
    {
      buffer1=databuffer;
      adset=0;buffernum=11;bufferi=6;
      Displaybuffer[6]=seg[12];  
      Displaybuffer[7]=seg[10];    
      Displaybuffer[8]=seg[16];  
      Displaybuffer[9]=seg[2];   
      Displaybuffer[10]=seg[0];
      break;
    }
    case 1:
    {
      adset=10;
      buffernum=16;bufferi=11;
      buffer2=databuffer;
      Displaybuffer[11]=seg[buffer2/10000];
      buffer2=buffer2%10000;
      Displaybuffer[12]=seg[buffer2/1000];
      buffer2=buffer2%1000;
      Displaybuffer[13]=seg[buffer2/100]+1;
      buffer2=buffer2%100;
      Displaybuffer[14]=seg[buffer2/10];
      buffer2=buffer2%10;
      Displaybuffer[15]=seg[buffer2];
      Displaybuffer[16]=0xff;
      Displaybuffer[17]=0xff;
      Displaybuffer[18]=0xff;
      Displaybuffer[19]=0xff;
      break;
    }    
    case 2:
    {
      adset=20;bufferi=16;buffernum=20;
      if(lcd_2==0)
      {
        if(lcd_1==1)
        {
         buf[1]=databuffer;
         buf[0]=0;buf[2]=0;buf[3]=0;
        }
        else if(lcd_1>1)
        {
         buf[0]=buf[1];
         buf[1]=databuffer;
        }
      }
      else if(lcd_2==1)
      {
        if(lcd_1==1)
        buf[2]=databuffer;
        else if(lcd_1==2)
        buf[3]=databuffer;
      }
      a=buf[0];b=buf[1];c=buf[2];d=buf[3];
      price=buf[0]*1000+buf[1]*100+buf[2]*10+buf[3];
      Displaybuffer[16]=seg[a];
      Displaybuffer[17]=seg[b]+1;
      Displaybuffer[18]=seg[c];
      Displaybuffer[19]=seg[d];
      break;
	 }
	}	 

  RAM2LCD(&Displaybuffer[bufferi],buffernum-bufferi);

}

void Delay(unsigned int num)
{
  volatile unsigned int d;
  for(d=0;d<=num;d++);asm("NOP");
}

/*------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/
/* Hardware Communication Interrupt                                          */
/* UART/SPI/I2C Interrupt Service Routines                                   */
/*---------------------------------------------------------------------------*/
void HW0_ISR(void)
{
  unsigned char I2C_Status;

  if(DrvI2C_ReadIntFlag()==E_DRVI2C_INT)  // Get I2C Interrupt Flag
  {
    I2C_Status=DrvI2C_GetStatusFlag();  // Get I2C Status Flag
    switch(I2C_Status)
    {
      case 0x90: //MACTFlag+RWFlag
          { /* START has been transmitted */
            DrvI2C_WriteData(I2C_TARGET);  //Send Slave Address & R/W Bit
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          };
      case 0x84: //MACTFlag+ACKFlag
          { /* Slave A + W has been transmitted. ACK has been received. */
            DrvI2C_WriteData(Sendbuf[DataTxIndex++]);  //Send Data to Slave
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          };
      case 0x80: //MACTFlag
          { /* Slave A + W has been transmitted. ACK has been received. */
            DrvI2C_WriteData(Sendbuf[DataTxIndex++]);  //Send Data to Slave
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          };
      case 0x30:
          {
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            EndFlag=1;
            break;
          };
      case 0x8C: // MACTFlag+DFFlag+ACKFlag
          { /* DATA has been transmitted and ACK has been received */
            if(DataTxIndex<DataTxLen)
            {
              DrvI2C_WriteData(Sendbuf[DataTxIndex++]);  //Send Data to Slave
              DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            }
            else
            {
              if(I2C_RW == WRITE)
              {
                DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
                EndFlag=1;
              }
              else if(I2C_RW == READ)
                DrvI2C_Ctrl(1,0,0,0);  // I2C as master sends START signal
              DataTxIndex=0;
            }
            break;
          };
      case 0x88: //MACTFlag+DFFlag
          { /* DATA has been transmitted and NACK has been received */
            DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
            DataTxIndex=0;
            EndFlag=1;
            break;
          };
      case 0xB0:
          { /* A repeated START has been transmitted. */
            DrvI2C_WriteData(I2C_TARGET | READ);  //Send Slave Address & R/W Bit
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            break;
          }
      case 0x94: //MACTFlag+RWFlag
          { /* Slave A + R has been transmitted. ACK has been received. */
            DrvI2C_Ctrl(0,0,0,1);  // Set ACK bit
            break;
          };
      case 0x9C: //MACTFlag+RWFlag+DFFlag+ACKFlag
          { /* Data byte has been received. ACK has been transmitted. */
            if(DataRxLen>DataRxIndex)
            {
              Recbuf[DataRxIndex++]=DrvI2C_ReadData();
              DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            }
            else
            {
              Recbuf[DataRxIndex++]=DrvI2C_ReadData();
              DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
              EndFlag=1;
            }
            break;
          };
      case 0x98: //MACTFlag+RWFlag+DFFlag
          { /* Data byte has been received. NACK has been transmitted. */
            DrvI2C_Ctrl(0,1,0,0);  // I2C as master sends STOP signal
            EndFlag=1;
            break;
          };
      default:
          {
            DrvI2C_Ctrl(0,0,0,0);  // Clear all I2C flag
            EndFlag=1;
            break;
          };
    }
    DrvI2C_ClearEIRQ();
    DrvI2C_ClearIntFlag(2); // Clear I2C Interrupt Flag(I2CIF)
    SYS_EnableGIE(7,0x3F);       // Enable GIE(Global Interrupt)
  }
  if(DrvI2C_ReadIntFlag()==E_DRVI2C_ERROR_INT)  //Get I2C Error Interrupt Flag
  {
    EndFlag=1;
    DrvI2C_ClearIRQ();
    DrvI2C_ClearIntFlag(2); // Clear I2C Interrupt Flag(I2CEIF)
    DrvI2C_Ctrl(0,1,0,0);   // I2C as master sends STOP signal
    SYS_EnableGIE(7,0x3F);       // Enable GIE(Global Interrupt)
  }
}



void HW2_ISR(void)
{
  DrvADC_ClearIntFlag(); // clear ADC interrupt flag
  indec=DrvADC_GetConversionData(); //get ADC convert data
  indec=indec>>15;
  interrupt_flag=1;
}
